/******************************************************************************/
/*   This program is developed by Borland C++ 3.1                             */
/******************************************************************************/
/*  Demo 16: One P1602 Card demo.                                             */
/*   To estimate the performance for P1602_Do(), P1602_Di() and P1602_Da().   */
/******************************************************************************/
#define  MYLIB
#include <time.h>
#include "P1602.H"

clock_t StartTick,EndTick;
int main()
{
   int     i,j;
   WORD    wBoards,wRetVal;
   WORD    wDIOdata,wOutput;
   float   fSeconds,fMHz;
   DWORD   dwI;
   WORD    wAddrTimer,wAddrCtrl,wAddrDio,wAddrAdda;

   clrscr();

   /* initiaing P1602 card and detect how many P1602 card in PC */
   wRetVal=P1602_DriverInit(&wBoards);
   printf("Threr are %d P1602 Cards in this PC\n",wBoards);

   if( wBoards==0 )
   {
      putch(0x07);  putch(0x07);  putch(0x07);
      printf("There are no P1602 card in this PC !!!\n");
      exit(0);
   }

   /* dump every P1602 card's configuration address space */
   printf("The Configuration Space ->   Timer   Control   DIO    AD/DA\n");
   for(i=0; i<wBoards; i++)
   {
      P1602_GetConfigAddressSpace(i,&wAddrTimer,&wAddrCtrl,&wAddrDio,&wAddrAdda);
      printf("Card %02d:  Timer:%04xH  Ctrl:%04xH  Dio:%04xH  Adda:%04xH\n",
                                     i,wAddrTimer,wAddrCtrl,wAddrDio,wAddrAdda);
   }

   P1602_ActiveBoard( 0 );
   StartTick=clock();
   i=0;
   printf("Estimating the performance of P1602_Do(), please waiting...\n");
   for(dwI=0; dwI<1000000L; dwI++)
   {
      P1602_Do(wOutput);     /* Digital output */
   }
   EndTick=clock();
   fSeconds=(EndTick-StartTick)/CLK_TCK;
   fMHz=1.0/fSeconds;
   printf("StartTick:%ld   EndTick=%d\n",StartTick,EndTick);
   printf("It takes %5.3f second to run 1,000,000 times P1602_Do() !!!\n",fSeconds);
   printf("The performance of P1602_Do() is %5.2f MHz.\n",fMHz);
   printf("\n");

   StartTick=clock();
   printf("Estimating the performance of P1602_Di(), please waiting...\n");
   for(dwI=0; dwI<1000000L; dwI++)
   {
      P1602_Di(&wDIOdata);     /* Digital output */
   }
   EndTick=clock();
   fSeconds=(EndTick-StartTick)/CLK_TCK;
   fMHz=1.0/fSeconds;
   printf("StartTick:%ld   EndTick=%d\n",StartTick,EndTick);
   printf("It takes %5.3f second to run 1,000,000 times P1602_Di() !!!\n",fSeconds);
   printf("The performance of P1602_Di() is %5.2f MHz.\n",fMHz);
   printf("\n");

   StartTick=clock();
   printf("Estimating the performance of P1602_Da(), please waiting...\n");
   for(dwI=0; dwI<1000000L; dwI++)
   {
      P1602_Da(0,0x900);   /* DA CH:0 output 0x900 */
   }
   EndTick=clock();
   fSeconds=(EndTick-StartTick)/CLK_TCK;
   fMHz=1.0/fSeconds;
   printf("StartTick:%ld   EndTick=%d\n",StartTick,EndTick);
   printf("It takes %5.3f second to run 1,000,000 times P1602_Da() !!!\n",fSeconds);
   printf("The performance of P1602_Da() is %5.2f MHz.\n",fMHz);
   printf("\n");

   P1602_DriverClose();
   return 0;
}
