/**********************************************************************/
/*   This program is developed by MicroSoft C 5.1                      */
/***********************************************************************/
/*  Demo 6: two board P1602 cards M_FUN_1 demo.                        */
/***********************************************************************/
#define  MYLIB
#include "P1602.H"

int     iLine;
float   fAdBuf[510];
DWORD   dwDaFreq0,dwDaFreq1;
WORD    wAdClk0,wAdClk1;

WORD     wPlot0[512]; //  transformed into wave form
int main()
{
   int     i,j;
   WORD    wBoards,wRetVal;
   WORD    wDIOdata;
   char    cShow[80];
   DWORD   dwExact,dwOKs,dwErrors,dwScanCount,dwP1,dwP2,dwStatus;
   WORD    wDaWave=50,wAdNum=510;
   double  dfDaMagnitude=(double)2.5,dfAdFrequency;
   float   fSampleRate0,fSampleRate1;
   WORD    wAddrTimer,wAddrCtrl,wAddrDio,wAddrAdda;

   _clearscreen(0);
   gotoxy(1,1);

   // initiaing P1602 card and detect how many P1602 card in PC
   wRetVal=P1602_DriverInit(&wBoards);
   printf("Threr are %d P1602 Cards in this PC\n",wBoards);

   if( wBoards<=1 )
   {
      putch(0x07);  putch(0x07);  putch(0x07);
      printf("Please install two P1602 cards in this PC !!!\n");
      exit(0);
   }

   /* dump every P1602 card's configuration address space */
   printf("The Configuration Space ->   Timer   Control   DIO    AD/DA\n");
   for(i=0; i<wBoards; i++)
   {
      P1602_GetConfigAddressSpace(i,&wAddrTimer,&wAddrCtrl,&wAddrDio,&wAddrAdda);
      printf("Card %02d:  Timer:%04xH  Ctrl:%04xH  Dio:%04xH  Adda:%04xH\n",
                                     i,wAddrTimer,wAddrCtrl,wAddrDio,wAddrAdda);
   }

   // The P1602_ActiveBoard() function must be used to active a board,
   // then all operation will take effect to the actived board.
   printf("----------------------------------------------------------\n");
   printf("The First P1602 Card...\n");
   P1602_ActiveBoard( 0 );
   P1602_Do(0x1234);     // Digital output
   P1602_Di(&wDIOdata);  // Digital input
   printf("Digital Output -> 1234H  |  Digital Input -> %04xH\n",wDIOdata);
   printf("----------------------------------------------------------\n");
   printf("The Second P1602 Card...\n");
   P1602_ActiveBoard( 1 );
   P1602_Do(0x5678);     // Digital output
   P1602_Di(&wDIOdata);  // Digital input
   printf("Digital Output -> 5678H  |  Digital Input -> %04xH\n",wDIOdata);
   printf("\n\n");

   // The D/A output wave form generator is a machine dependent function.
   // The D/A output frequency:
   //   for Pemtium-120  ->  D/A output freqency=1.8M/dwDaFreq
   //   for Pemtium-133  ->  D/A output freqency=2.0M/dwDaFreq
   // suggestion: dwDaFreq=90
   printf("(1st Card)Please Enter the Frequency for D/A(suggestion 90) -> ");
   scanf("%ld",&dwDaFreq0);
   // Enter wAdClk, the A/D sampling rate is 8M/wAdClk
   // suggestion: wAdClk=24
   printf("(1st Card)Please Enter wAdClk(suggestion 24) -> ");
   scanf("%d",&wAdClk0);  printf("\n");
   fSampleRate0=8000.0/wAdClk0;  // A/D is fSampleRate Khz

   printf("(2nd Card)Please Enter the Frequency for D/A(suggestion 90) -> ");
   scanf("%ld",&dwDaFreq1);
   // Enter wAdClk, the A/D sampling rate is 8M/wAdClk
   // suggestion: wAdClk=24
   printf("(1st Card)Please Enter wAdClk(suggestion 24) -> ");
   scanf("%d",&wAdClk1);  printf("\n");
   fSampleRate1=8000.0/wAdClk1;  // A/D is fSampleRate Khz

   /************** M1 Function  ****************************/
   //--------- To Active First P1602 Card --------------------
   P1602_ActiveBoard( 0 );

   for(i=0; i<510; i++) fAdBuf[i]=0.0;
   wRetVal=P1602_M_FUN_1(dwDaFreq0,wDaWave,dfDaMagnitude,wAdClk0,wAdNum,
                          0,fAdBuf,-10.0,+10.0);

   if (wRetVal==0)
   {
      printf(cShow,"1st Card: P1602_M_FUN_1 OK, Sample Rate is %7.3fK",fSampleRate0);
   }
   else
   {
      putch(0x07);
      printf("1st Card: P1602_M_FUN_1 ERROR, return=%x\n\n",wRetVal);
      exit(0);
   }

   printf("[ 0]=%+4.3f, [ 1]=%+4.3f, [ 2]=%+4.3f, [ 3]=%+4.3f\n",
           fAdBuf[0],fAdBuf[1],fAdBuf[2],fAdBuf[3]);

   printf("[ 4]=%+4.3f, [ 5]=%+4.3f, [ 6]=%+4.3f, [ 7]=%+4.3f\n",
           fAdBuf[4],fAdBuf[5],fAdBuf[6],fAdBuf[7]);

   printf("[ 8]=%+4.3f, [ 9]=%+4.3f, [10]=%+4.3f, [11]=%+4.3f\n",
           fAdBuf[8],fAdBuf[9],fAdBuf[10],fAdBuf[11]);

   printf("[12]=%+4.3f, [13]=%+4.3f, [14]=%+4.3f, [15]=%+4.3f\n",
           fAdBuf[12],fAdBuf[13],fAdBuf[14],fAdBuf[15]);

   printf("[16]=%+4.3f, [17]=%+4.3f, [18]=%+4.3f, [19]=%+4.3f\n",
           fAdBuf[16],fAdBuf[17],fAdBuf[18],fAdBuf[19]);



   //--------- To Active Second P1602 Card --------------------
   P1602_ActiveBoard( 1 );

   for(i=0; i<510; i++) fAdBuf[i]=0.0;
   wRetVal=P1602_M_FUN_1(dwDaFreq1,wDaWave,dfDaMagnitude,wAdClk1,wAdNum,
                          0,fAdBuf,-10.0,+10.0);

   if (wRetVal==0)
   {
     printf("2nd Card: P1602_M_FUN_1 OK, Sample Rate is %7.3fK",fSampleRate0);
   }
   else
   {
     putch(0x07);
     printf("2nd: P1602_M_FUN_1 ERROR, return=%x\n\n",wRetVal);
     exit(0);
   }

   printf("[ 0]=%+4.3f, [ 1]=%+4.3f, [ 2]=%+4.3f, [ 3]=%+4.3f\n",
           fAdBuf[0],fAdBuf[1],fAdBuf[2],fAdBuf[3]);

   printf("[ 4]=%+4.3f, [ 5]=%+4.3f, [ 6]=%+4.3f, [ 7]=%+4.3f\n",
           fAdBuf[4],fAdBuf[5],fAdBuf[6],fAdBuf[7]);

   printf("[ 8]=%+4.3f, [ 9]=%+4.3f, [10]=%+4.3f, [11]=%+4.3f\n",
           fAdBuf[8],fAdBuf[9],fAdBuf[10],fAdBuf[11]);

   printf("[12]=%+4.3f, [13]=%+4.3f, [14]=%+4.3f, [15]=%+4.3f\n",
           fAdBuf[12],fAdBuf[13],fAdBuf[14],fAdBuf[15]);

   printf("[16]=%+4.3f, [17]=%+4.3f, [18]=%+4.3f, [19]=%+4.3f\n",
           fAdBuf[16],fAdBuf[17],fAdBuf[18],fAdBuf[19]);

   P1602_DriverClose();
   return 0;
}
