/**********************************************************************/
/*   This program is developed by MicroSoft C 5.1                      */
/***********************************************************************/
/*  Demo 7: one P1602 card M_FUN_2 demo.                               */
/***********************************************************************/
#define  MYLIB
#include "P1602.H"

int     iLine;
float   fAdBuf[510];
WORD    wAdClk;

WORD     wDa[320],wAd[510];
WORD     wPlot0[512]; //  transformed into wave form

int main()
{
   int     i,j;
   WORD    wBoards,wRetVal;
   WORD    wDIOdata;
   DWORD   dwExact,dwOKs,dwErrors,dwScanCount,dwP1,dwP2,dwStatus;
   double  dfAdFrequency;
   float   fSampleRate;
   WORD    wAddrTimer,wAddrCtrl,wAddrDio,wAddrAdda;

   _clearscreen(0);
   gotoxy(1,1);

   // initiaing P1602 card and detect how many P1602 card in PC
   wRetVal=P1602_DriverInit(&wBoards);
   printf("Threr are %d P1602 Cards in this PC\n",wBoards);

   if( wBoards==0 )
   {
      putch(0x07);  putch(0x07);  putch(0x07);
      printf("There are no P1602 card in this PC !!!\n");
      exit(0);
   }

   /* dump every P1602 card's configuration address space */
   printf("The Configuration Space ->   Timer   Control   DIO    AD/DA\n");
   for(i=0; i<wBoards; i++)
   {
      P1602_GetConfigAddressSpace(i,&wAddrTimer,&wAddrCtrl,&wAddrDio,&wAddrAdda);
      printf("Card %02d:  Timer:%04xH  Ctrl:%04xH  Dio:%04xH  Adda:%04xH\n",
                                     i,wAddrTimer,wAddrCtrl,wAddrDio,wAddrAdda);
   }

   // The P1602_ActiveBoard() function must be used to active a board,
   // then all operation will take effect to the actived board.
   P1602_ActiveBoard( 0 );

   P1602_Do(0x1234);     // Digital output
   P1602_Di(&wDIOdata);  // Digital input
   printf("Digital Output -> 1234H  |  Digital Input -> %04xH\n",wDIOdata);
   printf("\n");

   /************** M2 Function  ****************************/
   for(i=0; i<64; i++) wDa[i]=0x800-i*16;
   for(i=0; i<64; i++) wDa[i+64]=0x800-(64-i)*16;
   for(i=0; i<64; i++) wDa[i+64*2]=0x800;
   for(i=0; i<64; i++) wDa[i+64*3]=0x800-64*8;
   for(i=0; i<64; i++) wDa[i+64*4]=0x800;

   for (i=0; i<510; i++)
   {
      wAd[i]=0;
   }

   wRetVal=P1602_M_FUN_2(320,15,wDa,24,510,0,wAd);
   if (wRetVal==0)
        printf("P1802_M_FUN_2 OK\n");
   else
        printf("P1802_M_FUN_2 ERROR, return=%x\n",wRetVal);

   printf("[ 0]=%04xH, [ 1]=%04xH, [ 2]=%04xH, [ 3]=%04xH\n",
           wAd[0],wAd[1],wAd[2],wAd[3]);

   printf("[ 4]=%04xH, [ 5]=%04xH, [ 6]=%04xH, [ 7]=%04xH\n",
           wAd[4],wAd[5],wAd[6],wAd[7]);

   printf("[ 8]=%04xH, [ 9]=%04xH, [10]=%04xH, [11]=%04xH\n",
           wAd[8],wAd[9],wAd[10],wAd[11]);

   printf("[12]=%04xH, [13]=%04xH, [14]=%04xH, [15]=%04xH\n",
           wAd[12],wAd[13],wAd[14],wAd[15]);

   printf("[16]=%04xH, [17]=%04xH, [18]=%04xH, [19]=%04xH\n",
           wAd[16],wAd[17],wAd[18],wAd[19]);

   P1602_DriverClose();
   return 0;
}

